.org 0x10000000

# DESCRIPTION:
# This program reads the first 4 switches and uses a lookup table to 
# convert the value to a encodings to be shown on a seven segment display

# Initializations
li $s0, 0xf0a00000	# Seven segment display address
li $s1, 0xf0100000	# Switch address

main:
	li $t0, 0		# Counter
	li $t1, 0xffffff00	# Value written to seven segment display
	li $t2, SSEG_LUT	# Lookup Table (LUT) address 
	lw $t3, 0($s1)	# Read value from switches
	andi $t3, $t3, 0xf	# Mask least significant 4 bits
	sll $t3, $t3, 2	# Multiply switch value by 2^2 to get LUT address offset
	addu $t3, $t3, $t2	# Add offset to LUT address
	lw $t4, 0($t3)	# Read value from lookup table
	or $t1, $t1, $t4	# Set least significant digit to value from lookup table
	sw $t1, 0($s0)	# Set value on seven segment display
	j main
	nop

# Seven segment display lookup table
SSEG_LUT:
.word 	0xc0	# 0
.word	0xf9	# 1
.word	0xa4	# 2
.word	0xb0	# 3
.word	0x99	# 4
.word	0x92	# 5
.word	0x82	# 6
.word	0xf8	# 7
.word	0x80	# 8
.word	0x90	# 9
.word	0x88	# a
.word	0x83	# b
.word	0xc6	# c
.word	0xa1	# d
.word	0x86	# e
.word	0x8e	# f
.word	0xff	# All segments off